RGM.Interface = {{Build = {}, Data = {}, Mouse = {}, Temp = {}}}

function RGM.Build.Interface()
	local Gsub, Match, String, Upper = string.gsub, string.match, string.format, string.upper
	local E, G, I, S, W, O = RGM, RGM.Global, RGM.Interface[1], RGM.Interface[2], 148
	local Effects = {colorR = 0.88, colorG = 0.88, colorB = 0.88}
	local Context, Frame = UI.CreateContext, UI.CreateFrame
	local Next, Pairs, Inspect = next, pairs, Inspect
	local Integer, Sort = math.floor, table.sort
	local User = Inspect.Unit.Detail("player")
	local T, F = true, false

	if RGM_Global then
		G = (RGM_Global and RGM_Global[1])
	else
		RGM_Global = E.Global
		G = RGM_Global[1]
	end

	if I and S then
		G, I, S = RGM_Global[2], S, I
	end

	if not G.Show and not (G.Show == F) then
		G.Show = T
	end

	if not G.MiniX or not G.MiniY then
		G.MiniShow = F
		G.MiniX = 0
		G.MiniY = 0
	end

	if G and G.Width then
		W = G.Width
	end

	I.Main = Context("Main")

	I.MainBG = Frame("Texture", "Main BG", I.Main)
	I.Units = Frame("Text", "Units", I.Main)
	I.Time = Frame("Text", "Time", I.Main)
	I.Events = Frame("Frame", "Events", I.Main)
	I.EventsBG = Frame("Texture", "Events BG", I.Events)
	I.EventsTX = Frame("Text", "Events Text", I.Events)
	I.Mini = Frame("Frame", "Mini Menu", I.Main)
	I.MiniBG = Frame("Texture", "Mini BG", I.Mini)
	I.MiniTX = Frame("Text", "Mini Text", I.Mini)
	I.Tip = Frame("Frame", "Tooltip", I.Main)
	I.TipBG = Frame("Texture", "Tooltip BG", I.Tip)
	I.TipTX = Frame("Text", "Tooltip Text", I.Tip)
	I.Log = Frame("Frame", "Combat Log", I.Main)
	I.LogBG = Frame("Texture", "Combat Log BG", I.Log)
	I.LogTX = Frame("Text", "Combat Log Text", I.Log)
	I.Copy = Frame("RiftTextfield", "Report", I.Main)

	I.Main:SetPoint(G.Point[1], UIParent, "CENTER", G.MainX, G.MainY)
	I.Main:SetVisible(G.Show)
	I.Main:SetLayer(2)

	I.MainBG:SetPoint("CENTER", I.Main, "CENTER", 0, 0)
	I.MainBG:SetTexture("RGM", "TBGM.png")
	I.MainBG:SetAlpha(0.08)
	I.MainBG:SetLayer(4)

	I.Units:SetPoint("TOPLEFT", I.Main, "TOPLEFT", 6, 24)
	I.Units:SetFontSize(14)
	I.Units:SetWidth(W)
	I.Units:SetLayer(6)

	I.Time:SetPoint("TOPLEFT", I.Main, "TOPLEFT", 6.88, 4)
	I.Time:SetText("00:00")
	I.Time:SetFontSize(14)
	I.Time:SetLayer(6)

	I.Events:SetPoint("TOPRIGHT", I.Main, "TOPRIGHT", 0, 28)
	I.Events:SetVisible(F)
	I.Events:SetLayer(8)

	I.EventsBG:SetPoint("CENTER", I.Events, "CENTER", 0, 0)
	I.EventsBG:SetTexture("RGM", "TBGM.png")
	I.EventsBG:SetAlpha(0.08)
	I.EventsBG:SetLayer(10)

	I.EventsTX:SetPoint("CENTER", I.Events, "CENTER", 0, 0)
	I.EventsTX:SetFontSize(14)
	I.EventsTX:SetLayer(12)

	I.Mini:SetPoint("CENTER", UIParent, "CENTER", G.MiniX, G.MiniY)
	I.Mini:SetVisible(G.MiniShow)
	I.Mini:SetLayer(8)

	I.MiniBG:SetPoint("CENTER", I.Mini, "CENTER", 0, 0)
	I.MiniBG:SetTexture("RGM", "TBGM.png")
	I.MiniBG:SetAlpha(0.08)
	I.MiniBG:SetLayer(10)

	I.MiniTX:SetPoint("CENTER", I.Mini, "CENTER", 0, 0)
	I.MiniTX:SetFontSize(14)
	I.MiniTX:SetLayer(12)

	I.Tip:SetPoint(G.Point[2], UIParent, "CENTER", G.TipX, G.TipY)
	I.Tip:SetVisible(F)
	I.Tip:SetLayer(8)

	I.TipBG:SetPoint("CENTER", I.Tip, "CENTER", 0, 0)
	I.TipBG:SetTexture("RGM", "TBGT.png")
	I.TipBG:SetAlpha(0.20)
	I.TipBG:SetLayer(10)

	I.TipTX:SetPoint("CENTER", I.Tip, "CENTER", 0, 0.88)
	I.TipTX:SetFontSize(14)
	I.TipTX:SetLayer(12)

	I.Log:SetPoint("CENTER", UIParent, "CENTER", G.LogX, G.LogY)
	I.Log:SetVisible(F)
	I.Log:SetLayer(8)

	I.LogBG:SetPoint("CENTER", I.Log, "CENTER", 0, 0)
	I.LogBG:SetTexture("RGM", "TBGM.png")
	I.LogBG:SetAlpha(0.088)
	I.LogBG:SetLayer(10)

	I.LogTX:SetPoint("TOPCENTER", I.Log, "TOPCENTER", 0, 8)
	I.LogTX:SetFontSize(14)
	I.LogTX:SetLayer(12)

	I.Copy:SetPoint("BOTTOMLEFT", I.Main, "BOTTOMLEFT", 6, -4)
	I.Copy:SetWidth(148.8)
	I.Copy:SetVisible(F)
	I.Copy:SetLayer(12)

	function I.Main.Event.LeftDown()
		if not I.Temp.Complete and G.Lock then return end
		
		local G = (I.Temp.Complete or G)
		local Mouse = Inspect.Mouse()
		
		I.Mouse.GlobalX = G.MainX
		I.Mouse.GlobalY = G.MainY
		I.Mouse.MainX = Mouse.x
		I.Mouse.MainY = Mouse.y
		I.Mouse.LeftM = T
	end

	function I.Main.Event.LeftUp()
		if I.Mouse then I.Mouse = {} end
		I.Update(I.Session(O, 0))
	end

	function I.Main.Event.RightClick()
		if I.Temp.Complete then return end
		
		G.Lock = not G.Lock
		
		if not G.Lock then
			print("Panel now: Unlocked")
		else
			print("Panel now: Locked")
		end
	end

	function I.Main.Event.MiddleClick()
		if I.Mouse.LeftM or I.Temp.Complete then return end
		
		if G.Point[1] == "BOTTOMCENTER" then
			print("Panel growth: Center")
			G.Point[1] = "CENTER"
		elseif G.Point[1] == "CENTER" then
			print("Panel growth: Down")
			G.Point[1] = "TOPCENTER"
		elseif G.Point[1] == "TOPCENTER" then
			print("Panel growth: Up")
			G.Point[1] = "BOTTOMCENTER"
		end
		
		if I.Main and G.Point[1] then
			I.Main.Reset()
		end
		
		I.Main:SetPoint(G.Point[1], UIParent, "CENTER", G.MainX, G.MainY)
	end

	function I.Main.Event.MouseMove()
		local G = (I.Temp.Complete or G)
		local Mouse = Inspect.Mouse()
		
		if I.Mouse.LeftM then
			G.MainX = Mouse.x - I.Mouse.MainX + I.Mouse.GlobalX
			G.MainY = Mouse.y - I.Mouse.MainY + I.Mouse.GlobalY
			
			if I.Temp.Complete then
				I.Main:SetPoint("CENTER", UIParent, "CENTER", G.MainX, G.MainY)
			else
				I.Main:SetPoint(G.Point[1], UIParent, "CENTER", G.MainX, G.MainY)
			end
		end
	end

	function I.Main.Event.WheelBack()
		if I.Mouse.LeftM or I.Temp.Complete or I.Units:GetWidth() == 148 or G.Lock then return else I.Units:SetText("") end
		
		I.Main:SetWidth(I.Units:GetWidth() - 10 + (48 * G.Modes) + (4 * G.Modes))
		I.Units:SetWidth(I.Units:GetWidth() - 20)
		I.MainBG:SetWidth(I.Main:GetWidth() - 8)
		
		G.Width = I.Units:GetWidth()
		I.Update(I.Session(O, 0))
	end

	function I.Main.Event.WheelForward()
		if I.Mouse.LeftM or I.Temp.Complete or I.Units:GetWidth() == 288 or G.Lock then return else I.Units:SetText("") end
		
		I.Main:SetWidth(I.Units:GetWidth() + 30 + (48 * G.Modes) + (4 * G.Modes))
		I.Units:SetWidth(I.Units:GetWidth() + 20)
		I.MainBG:SetWidth(I.Main:GetWidth() - 8)
		
		G.Width = I.Units:GetWidth()
		I.Update(I.Session(O, 0))
	end

	function I.Main.Reset()
		local Reset = I.Main:ClearAll()
		
		I.Main:SetWidth(I.Units:GetWidth() + 10 + (48 * G.Modes) + (4 * G.Modes))
		I.Main:SetHeight(I.Units:GetHeight() + 24.00)
		
		if Next(I.Data) then
			I.Session()
		end
	end

	function I.Units.Event.LeftClick()
		local Data = I.Select("Units", I.Units:GetTop()) or (I.Data[Integer(I.Temp.Units)] and I.Data[Integer(I.Temp.Units)].Detail)
		local Index = Integer(I.Temp.Units)
		local Session = I.Session(0, 0, 0)
		
		if Index > #I.Data or Index > G.Slots.Stop then
			return
		end
		
		if Data and Data.Unit then
			local Unit = (Session and Session[Data.Unit] or Data.Unit)
			local Log = (Unit.Log and Next(Unit.Log))
			
			if Unit and Log then
				I.Log.Update(Unit.Log, Unit.Name)
			else
				Data = F
			end
		else
			Data = F
		end
		
		if not Session or not Data or I.Log:GetVisible() then
			I.Temp.Units = I.Log:SetVisible(F)
			I.Temp.Log = I.LogTX:SetText("")
		else
			I.Log:SetVisible(T)
		end
	end

	function I.Units.Event.MouseOut()
		I.Temp.Units = O
	end

	function I.Units.Event.WheelBack()
		if I.Data and #I.Data > G.Slots.Stop then
			G.Slots.Start = G.Slots.Start + 1
			G.Slots.Stop = G.Slots.Stop + 1
			I.Session(G.Slots.Stop)
		end
	end

	function I.Units.Event.WheelForward()
		if I.Data and G.Slots.Start > 1 then
			G.Slots.Start = G.Slots.Start - 1
			G.Slots.Stop = G.Slots.Stop - 1
			I.Session(G.Slots.Stop)
		end
	end

	function I.Time.Event.LeftClick()
		I.Temp.Mini = not I.Temp.Mini
		G.MiniShow = not G.MiniShow
		
		I.Mini:SetVisible(G.MiniShow)
		I.Mini.Update(I.Temp.Mini)
		I.Mini.Position(F)
	end

	function I.Time.Event.MiddleClick()
		I.Latest()
	end

	function I.Time.Event.MouseIn()
		I.Time:SetEffectGlow(Effects)
	end

	function I.Time.Event.MouseOut()
		I.Time:SetEffectGlow(O)
	end

	function I.Time.Event.RightClick()
		G.MiniQuick = not G.MiniQuick
		
		if G.MiniQuick and not G.MiniShow then
			I.Time.Event.LeftClick()
		end
		
		I.Mini.Position(F)
	end

	function I.Time.Event.WheelBack()
		I.Mini.Change("Down", 9)
	end

	function I.Time.Event.WheelForward()
		I.Mini.Change("Up", 9)
	end

	function I.Events.Event.LeftClick()
		local Mode = "Mode" .. I.Temp.Mode
		local Item = I.Temp.Events
		
		if Item < 2 then
			G.Mode[I.Temp.Mode] = "ASB"
			I[Mode]:SetText("ASB")
		elseif Item < 3 then
			G.Mode[I.Temp.Mode] = "AVD"
			I[Mode]:SetText("AVD")
		elseif Item < 4 then
			G.Mode[I.Temp.Mode] = "BLK"
			I[Mode]:SetText("BLK")
		elseif Item < 5 then
			G.Mode[I.Temp.Mode] = "DMG"
			I[Mode]:SetText("DMG")
		elseif Item < 6 then
			G.Mode[I.Temp.Mode] = "DPS"
			I[Mode]:SetText("DPS")
		elseif Item < 7 then
			G.Mode[I.Temp.Mode] = "DTN"
			I[Mode]:SetText("DTN")
		elseif Item < 8 then
			G.Mode[I.Temp.Mode] = "INT"
			I[Mode]:SetText("INT")
		elseif Item < 9 then
			G.Mode[I.Temp.Mode] = "MSD"
			I[Mode]:SetText("MSD")
		elseif Item < 10 then
			G.Mode[I.Temp.Mode] = "OKL"
			I[Mode]:SetText("OKL")
		elseif Item < 11 then
			G.Mode[I.Temp.Mode] = "HLG"
			I[Mode]:SetText("HLG")
		elseif Item < 12 then
			G.Mode[I.Temp.Mode] = "HPS"
			I[Mode]:SetText("HPS")
		elseif Item < 13 then
			G.Mode[I.Temp.Mode] = "HTN"
			I[Mode]:SetText("HTN")
		elseif Item < 14 then
			G.Mode[I.Temp.Mode] = "OHG"
			I[Mode]:SetText("OHG")
		else
			G.Mode[I.Temp.Mode] = "OPS"
			I[Mode]:SetText("OPS")
		end
		
		I.Events:SetVisible(F)
		I.Temp.Events = O
		I.Temp.Mode = O
		I.Session(T)
	end

	function I.Events.Event.MouseMove()
		I.Select("Events", I.Events:GetTop())
	end

	function I.Events.Update(Input)
		local Text = String(" %0s \n %0s \n %0s \n %0s \n %0s \n %0s \n %0s \n %0s \n %0s", "Absorbed", "Avoided", "Blocked", "Damage", "Damage P/S", "Damage Taken", "Intercepted", "Missed", "Overkill")
		local Text = String("%0s \n %0s \n %0s \n %0s \n %0s \n %0s ", Text, "Healing", "Healing P/S", "Healing Taken", "Overheals", "Overheals P/S")
		
		if Input then
			I.Temp.Mode = (not I.Events:GetVisible() and Input or O)
		end
		
		if Text then
			I.Events:SetVisible(not I.Events:GetVisible())
			I.EventsTX:SetText(Text)
		end
		
		I.Events:SetHeight(I.EventsTX:GetHeight() + 8)
		I.EventsBG:SetHeight(I.Events:GetHeight() - 8)
		I.Events:SetWidth(I.EventsTX:GetWidth() + 8)
		I.EventsBG:SetWidth(I.Events:GetWidth() - 8)
	end

	function I.Mini.Change(Input, Item)
		local Session = (E.Active and #E.Sessions + 1 or #E.Sessions)
		local Item = (Item or I.Temp.Mini > 7 and I.Temp.Mini)
		
		if not Item then return end
		
		if Item < 8 then
			if Input == "Up" then
				G.Modes = (G.Modes < 14 and G.Modes or 13) + 1
			else
				G.Modes = (G.Modes > 2 and G.Modes or 2) - 1
			end
			
			I.Session(not I.Build.Modes(I.Mini.Update()))
		elseif Item < 9 then
			if Input == "Up" then
				G.Slots.Value = (G.Slots.Value == 28 and 1 or G.Slots.Value == 1 and 5 or G.Slots.Value + 1)
			else
				G.Slots.Value = (G.Slots.Value == 1 and 28 or G.Slots.Value > 5 and G.Slots.Value - 1 or 1)
			end
			
			G.Slots.Stop = G.Slots.Value
			I.Session()
		else
			if Input == "Up" then
				I.Temp.Index = (I.Temp.Index or Session) + 1
			else
				I.Temp.Index = (I.Temp.Index or Session) - 1
			end
			
			if I.Temp.Index and (I.Temp.Index > Session or I.Temp.Index == Session) then
				I.Temp.Index = O
			end
			
			if not E.Active and Session < 2 and I.Temp.Index and I.Temp.Index < 1 then
				I.Temp.Index = O
			end
			
			if I.Temp.Index and I.Temp.Index < 1 then
				I.Temp.Index = 001
			end
			
			if not E.Sessions[I.Temp.Index] then
				I.Temp.Index = O
			end
			
			I.Session(I.Clear())
		end
	end

	function I.Mini.Event.LeftClick()
		if G.MiniQuick and G.MiniMouse then G.MiniMouse = O return end
		
		local Complete = {MainX = 0, MainY = 0, Mode = {"ASB", "AVD", "BLK", "DMG", "DPS", "DTN", "HLG", "HPS", "HTN", "INT", "MSD", "OHG", "OKL", "OPS"}, Modes = 14, Sort = {G.Sort[1], G.Sort[2]}}
		local Global, Item, Update = RGM_Global, I.Temp.Mini, F
		local Player = Inspect.Unit.Detail("player")
		local S = (S or E.Interface[2])
		
		if Item < 2 then
			if not Update then
				E.Data, E.Extra, E.Ignore, E.Sessions, I.Data, I.Temp = {}, {}, {}, {}, {}, {Complete = I.Temp.Complete, Mode = I.Temp.Mode}
				E.Active = I.Clear()
			end
			
			if S and not Update then
				S.Data, S.Temp = {}, {Complete = S.Temp.Complete, Mode = S.Temp.Mode}
				S.Mini.Update(S.Clear())
			end
			
			if Player and Player.combat then
				E.Enter()
			end
		elseif Item < 3 then
			if E.Active and Next(E.Data) then
				Update = (I and not I.Session(not I.Clear()) and I.Mini.Update() or S and not S.Session(not S.Clear()) and S.Mini.Update())
				E.Active, E.Sessions[#E.Sessions + 1] = O, E.Clean(E.Data)
			end
		elseif Item < 4 then
			if not S and not Update then
				E.Interface[2] = {Build = {}, Data = {}, Mouse = {}, Temp = {}}
				S = (not E.Build.Interface() and E.Interface[2])
				S.Main:SetVisible(T)
			else
				S.Main:SetVisible(not S.Main:GetVisible())
			end
			
			if not (G == Global[1]) then
				Global[1].Show = S.Main:GetVisible()
			else
				Global[2].Show = S.Main:GetVisible()
			end
			
			Update = (not S.Main:GetVisible() and S.Clear() or S.Session(0))
		elseif Item < 5 then
			G.Side = (G.Side == "hostile" and "friendly" or "hostile")
			I.Session(I.Clear())
		elseif Item < 6 then
			I.Temp.Complete = ((not I.Temp.Complete or O) and Complete)
			I.Temp.Complete = (I.Main.Reset() or I.Temp.Complete)
			
			if not I.Temp.Complete then
				I.Main:SetPoint(G.Point[1], UIParent, "CENTER", G.MainX, G.MainY)
			else
				I.Main:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
			end
			
			Update = (I.Events:SetVisible(F) or I.Build.Modes() or I.Session())
		elseif Item < 7 then
			local Session = I.Session(0, 0)
			
			if Session and Session.Log and Next(Session.Log) then
				I.Log:SetVisible(not I.Log:GetVisible())
				I.Log.Update(Session.Log)
			else
				I.Log:SetVisible(F)
			end
			
			I.Temp.Log, I.Temp.Units = O, O
		else
			I.Mini.Change("Down")
			Update = T
		end
		
		if not G.MiniQuick and (Item and Item > 0 and not Update) then
			G.MiniShow = not G.MiniShow
			
			I.Mini:SetVisible(G.MiniShow)
			I.Temp.Mini = O
		end
	end

	function I.Mini.Event.LeftDown()
		if not G.MiniQuick then return end
		
		local Mouse = Inspect.Mouse()
		
		I.Mouse.GlobalX = G.MiniX
		I.Mouse.GlobalY = G.MiniY
		I.Mouse.MiniX = Mouse.x
		I.Mouse.MiniY = Mouse.y
		I.Mouse.LeftMi = T
	end

	function I.Mini.Event.LeftUp()
		if I.Mouse.GlobalX and not (I.Mouse.GlobalX == G.MiniX) then
			G.MiniMouse = T
		end
		
		I.Mouse = {}
	end

	function I.Mini.Event.MiddleClick()
		if I.Temp.Mini and I.Temp.Mini > 9 then
			I.Latest()
		end
	end

	function I.Mini.Event.MouseMove()
		local Mouse = Inspect.Mouse()
		
		if I.Mouse.LeftMi then
			G.MiniX = Mouse.x - I.Mouse.MiniX + I.Mouse.GlobalX
			G.MiniY = Mouse.y - I.Mouse.MiniY + I.Mouse.GlobalY
			
			I.Mini:SetPoint("CENTER", UIParent, "CENTER", G.MiniX, G.MiniY)
		end
		
		I.Select("Mini", I.Mini:GetTop())
	end

	function I.Mini.Event.MouseOut()
		I.Mini.Position()
	end

	function I.Mini.Event.RightClick()
		I.Mini.Change("Up")
	end

	function I.Mini.Event.WheelBack()
		I.Mini.Change("Down")
	end

	function I.Mini.Event.WheelForward()
		I.Mini.Change("Up")
	end

	function I.Mini.Position()
		local X = I.Main:GetLeft() - 902
		local Y = I.Main:GetTop() - 477
		
		if G.MiniQuick then
			I.Mini:SetPoint("CENTER", UIParent, "CENTER", G.MiniX, G.MiniY)
		else
			I.Mini:SetPoint("CENTER", UIParent, "CENTER", X, Y)
		end
	end

	function I.Mini.Update()
		local Session = (I.Temp.Index or E.Active and #E.Sessions + 1 or #E.Sessions)
		local Slots = (G.Slots.Value < 2 and "Self" or G.Slots.Value)
		local Panel = (I == E.Interface[2] and "Primary Panel")
		local Text = F
		
		if G.Side and G.Side == "friendly" then
			Text = String(" %0s \n %0s \n %0s \n %0s \n %0s \n %0s", "Delete Data", "New Session", (Panel or "Second Panel"), "Show Enemies", "All Data Modes", "Unit Death Log")
			Text = String("%0s \n %0s %0s \n %0s %0s \n %0s %0s ", Text, "Data Modes:", G.Modes, "Unit Slots:", Slots, "Session:", Session)
		else
			Text = String(" %0s \n %0s \n %0s \n %0s \n %0s \n %0s", "Delete Data", "New Session", (Panel or "Second Panel"), "Show Allies", "All Data Modes", "Unit Death Log")
			Text = String("%0s \n %0s %0s \n %0s %0s \n %0s %0s ", Text, "Data Modes:", G.Modes, "Unit Slots:", Slots, "Session:", Session)
		end
		
		if Text then
			I.MiniTX:SetText(Text)
		end
		
		I.Mini:SetHeight(I.MiniTX:GetHeight() + 8)
		I.MiniBG:SetHeight(I.Mini:GetHeight() - 8)
		I.Mini:SetWidth(I.MiniTX:GetWidth() + 8)
		I.MiniBG:SetWidth(I.Mini:GetWidth() - 8)
	end

	function I.Tip.Event.LeftDown()
		local Mouse = Inspect.Mouse()
		
		I.Mouse.AdvX = (I.Temp.TipX or 0)
		I.Mouse.AdvY = (I.Temp.TipY or 0)
		
		I.Mouse.GlobalX = G.TipX
		I.Mouse.GlobalY = G.TipY
		I.Mouse.TipX = Mouse.x
		I.Mouse.TipY = Mouse.y
		I.Mouse.LeftT = T
	end

	function I.Tip.Event.LeftUp()
		I.Mouse = {}
	end

	function I.Tip.Event.MouseIn()
		I.Temp.Tip = not I.Temp.Complete and G.Over
	end

	function I.Tip.Event.MouseMove()
		local Mouse = Inspect.Mouse()
		
		if I.Mouse.LeftT and I.Temp.Advanced then
			I.Temp.TipX = Mouse.x - I.Mouse.TipX + I.Mouse.AdvX
			I.Temp.TipY = Mouse.y - I.Mouse.TipY + I.Mouse.AdvY
			
			I.Tip:SetPoint("CENTER", UIParent, "CENTER", I.Temp.TipX, I.Temp.TipY)
		end
		
		if I.Mouse.LeftT and not I.Temp.Advanced then
			G.TipX = Mouse.x - I.Mouse.TipX + I.Mouse.GlobalX
			G.TipY = Mouse.y - I.Mouse.TipY + I.Mouse.GlobalY
			
			I.Tip:SetPoint(G.Point[2], UIParent, "CENTER", G.TipX, G.TipY)
		end
	end

	function I.Tip.Event.MouseOut()
		if I.Temp.Tip and not I.Temp.Advanced then I.Tooltip() end
		
		I.Temp.Tip = O
	end

	function I.Tip.Event.RightClick()
		if not I.Mouse.LeftT and (not I.Temp.Tip or I.Temp.Advanced) then
			I.Temp.Tip = I.Tooltip()
		end
	end

	function I.Log.Event.LeftDown()
		local Mouse = Inspect.Mouse()
		
		I.Mouse.GlobalX = G.LogX
		I.Mouse.GlobalY = G.LogY
		I.Mouse.LogX = Mouse.x
		I.Mouse.LogY = Mouse.y
		I.Mouse.LeftL = T
	end

	function I.Log.Event.LeftUp()
		I.Mouse = {}
	end

	function I.Log.Event.RightClick()
		if not I.Mouse.LeftL then I.Units.Event.LeftClick() end
	end

	function I.Log.Event.MouseMove()
		local Mouse = Inspect.Mouse()
		
		if I.Mouse.LeftL then
			G.LogX = Mouse.x - I.Mouse.LogX + I.Mouse.GlobalX
			G.LogY = Mouse.y - I.Mouse.LogY + I.Mouse.GlobalY
			I.Log:SetPoint("CENTER", UIParent, "CENTER", G.LogX, G.LogY)
		end
	end

	function I.Log.Event.WheelBack()
		I.Log.Scroll("Down")
	end

	function I.Log.Event.WheelForward()
		I.Log.Scroll("Up")
	end

	function I.Log.Scroll(Input)
		if not I.Temp.Log or not I.Temp.Log[1] then return end
		
		local Min = (#I.Temp.Log[1] < 24 and 1 or #I.Temp.Log[1] > 24 and #I.Temp.Log[1] - 23 or #I.Temp.Log[1] - 23)
		local Max = #I.Temp.Log[1]
		
		if Min and Max then
			I.Temp.Log[3] = (I.Temp.Log[3] or Min)
			I.Temp.Log[4] = (I.Temp.Log[4] or Max)
		end
		
		if I.Temp.Log[3] == 1 and Input == "Up" then
			return Min
		end
		
		if Input == "Down" then
			if Max > 24 and Min > 0 and I.Temp.Log[4] < Max + 1 then
				I.Temp.Log[3] = I.Temp.Log[3] + 1
				I.Temp.Log[4] = I.Temp.Log[4] + 1
			end
		else
			if Max > 24 and Min > 0 and I.Temp.Log[3] > 1 then
				I.Temp.Log[3] = I.Temp.Log[3] - 1
				I.Temp.Log[4] = I.Temp.Log[4] - 1
			end
		end
		
		if not (Max > 24 and Min > 0 and I.Temp.Log[4] < Max + 1) then
			I.Temp.Log[3], I.Temp.Log[4] = O, O
		end
		
		if #I.Temp.Log > 2 then
			I.Log.Update(I.Temp.Log[1], I.Temp.Log[2])
		end
	end

	function I.Log.Update(Input, Name)
		if not Input or not I.Temp then return end
		
		local Min = (I.Temp.Log and I.Temp.Log[3] or #Input < 24 and 1 or #Input > 24 and #Input - 23 or #Input - 23)
		local Max = (I.Temp.Log and I.Temp.Log[4] or #Input)
		local Text = Input[Min]
		
		if not I.Temp.Log then
			I.Temp.Log = {Input, Name}
		end
		
		for i = Min+1, Max do
			Text = String("%0s\n%0s", Text, Input[i])
		end
		
		if Text then
			I.LogTX:SetText(Text, T)
		else
			I.LogTX:SetText("")
		end
		
		if Text then
			I.LogBG:SetHeight(I.LogTX:GetHeight() + 8)
			I.Log:SetHeight(I.LogTX:GetHeight() + 16)
			I.LogBG:SetWidth(I.LogTX:GetWidth() + 4)
			I.Log:SetWidth(I.LogTX:GetWidth() + 12)
		end
	end

	function I.Copy.Event.KeyFocusLoss()
		I.Copy:SetKeyFocus(F)
		I.Copy:SetVisible(F)
		I.Copy:SetSelection()
	end

	function I.Copy.Event.KeyUp()
		I.Copy:SetKeyFocus(F)
		I.Copy:SetVisible(F)
		I.Copy:SetSelection()
	end

	function I.Build.Modes()
		local Global = (I.Temp.Complete or G)
		local Digits = tonumber
		
		for k,v in Pairs(I) do
			local Meter = Digits(Match(k, "Meter(%d+)"))
			local Mode = Digits(Match(k, "Mode(%d+)"))
			
			if Meter or Mode then
				if Meter and Meter > Global.Modes or Mode and Mode > Global.Modes then
					I[k]:SetVisible(F)
				else
					I[k]:SetVisible(T)
				end
			end
		end
		
		for i = 1, Global.Modes do
			local Meter = "Meter" .. i
			local Mode = "Mode" .. i
			
			if not I[Meter] and not I[Mode] then
				I[Meter] = Frame("Text", Meter, I.Main)
				I[Mode] = Frame("Text", Mode, I.Main)
				
				I[Meter]:SetPoint("TOPRIGHT", I.Units, "TOPRIGHT", 52 * i, 0)
				I[Meter]:SetFontSize(14)
				I[Meter]:SetWidth(48)
				I[Meter]:SetLayer(6)
				
				I[Mode]:SetPoint("TOPCENTER", I[Meter], "TOPCENTER", 0, -20)
				I[Mode]:SetFontSize(14)
				I[Mode]:SetLayer(6)
			end
			
			if Digits and Meter and Mode then
				Meter = I[Meter]
				Mode = I[Mode]
			end
			
			function Meter.Event.LeftClick()
				local Temp = I.Select("Meter", Meter:GetTop())
				local Run = I.Temp.Complete or not G.Over
				local Index = I.Temp.Meter
				
				if Index and Integer(Index) > #I.Data or Index and Integer(Index) > G.Slots.Stop then
					I.Temp.Meter = I.Report(I.Search(i), i, Global.Mode[i])
				end
				
				if Run and Index and G.Slots.Stop + 0.98 >= Index then
					I.Tooltip(I.Search(i), Global.Mode[i])
				end
			end
			
			function Meter.Event.MouseMove()
				local Run = I.Select("Meter", Meter:GetTop()) or not I.Temp.Advanced and not I.Temp.Complete and G.Over
				
				if Run and I.Temp.Meter and G.Slots.Stop + 0.98 >= I.Temp.Meter then
					I.Tooltip(I.Search(i), Global.Mode[i])
				end
				
				if Run and I.Temp.Meter and G.Slots.Stop + 0.98 < I.Temp.Meter then
					I.Tooltip()
				end
			end
			
			function Meter.Event.MouseOut()
				if not I.Temp.Tip and not I.Temp.Advanced and not I.Temp.Complete and G.Over then
					I.Tooltip()
				end
				
				I.Temp.Meter = O
			end
			
			function Meter.Event.RightClick()
				local Temp = I.Select("Meter", Meter:GetTop())
				
				if I.Temp.Meter and G.Slots.Stop + 0.98 >= I.Temp.Meter then
					I.Temp.Advanced = (not I.Temp.Advanced or O)
					I.Tooltip(I.Search(i), Global.Mode[i], 0)
				end
				
				I.Temp.TipX, I.Temp.TipY = O, O
			end
			
			function Meter.Event.WheelBack()
				I.Units.Event.WheelBack()
			end
			
			function Meter.Event.WheelForward()
				I.Units.Event.WheelForward()
			end
			
			function Mode.Event.LeftClick()
				if I.Temp and not I.Temp.Complete then
					I.Events.Update(i)
				end
			end
			
			function Mode.Event.RightClick()
				local Mode = (Global.Sort and I.Search(i))
				
				if Mode then
					if Global.Sort[1] == Mode.Event and Global.Sort[2] == Mode.Type then
						Global.Desc = not Global.Desc
					end
					
					Global.Sort[1] = Mode.Event
					Global.Sort[2] = Mode.Type
				end
				
				I.Session(T)
			end
			
			function Mode.Event.MouseIn()
				Mode:SetEffectGlow(Effects)
			end
			
			function Mode.Event.MouseOut()
				Mode:SetEffectGlow(O)
			end
			
			Mode:SetText(Global.Mode[i])
		end
		
		I.Main:SetWidth(I.Units:GetWidth() + 10 + (48 * Global.Modes) + (4 * Global.Modes))
		I.MainBG:SetWidth(I.Main:GetWidth() - 8)
	end

	function I.Clear(Input)
		local G = (I.Temp.Complete or G)
		local Digits = tonumber
		
		I.Time:SetText("00:00")
		I.Units:SetText("")
		
		if Digits then
			I.Temp.Log, I.Temp.Units = I.Log:SetVisible(F), I.Tooltip()
		end
		
		for k,v in Pairs(I) do
			local Meter = Digits(Match(k, "Meter(%d+)"))
			
			if G and I[k] and Meter then
				I[k]:SetText("")
			end
		end
		
		I.Main:SetHeight(I.Units:GetHeight() + 24.00)
		I.MainBG:SetHeight(I.Main:GetHeight() - 8)
	end

	function I.Count(I, K, V)
		if K == "Avoided" or K == "Missed" then
			return (I or 0) + (V["Critical Count"] or 0) + (V["Normal Count"] or 0)
		else
			return (I or 0) + (V["Critical Total"] or 0) + (V["Normal Total"] or 0)
		end
	end

	function I.Current(Input)
		if not E.Data.Time then return end
		
		local Time = E.Data.Time
		
		if Time and Time.Duration - (Time.Update or -2) > 1 then
			I.Session(Time.Duration > 0.2, I.Temp.Index)
			Input = (Input and Input.Current())
			Time.Update = Time.Duration
		end
	end

	function I.Density()
		I.Events:SetBackgroundColor(0.0, 0.0, 0.0, G.Density or 0.8)
		I.Main:SetBackgroundColor(0.0, 0.0, 0.0, G.Density or 0.8)
		I.Mini:SetBackgroundColor(0.0, 0.0, 0.0, G.Density or 0.8)
		
		I.Copy:SetBackgroundColor(0.0, 0.0, 0.0, 0.0)
		I.Tip:SetBackgroundColor(0.0, 0.0, 0.0, 0.8)
		I.Log:SetBackgroundColor(0.0, 0.0, 0.0, 0.8)
	end

	function I.Duration(Input)
		local Hour = Integer(Input.Time.Duration / 60 / 60)
		local Min = Integer(Input.Time.Duration / 60 % 60)
		local Sec = Input.Time.Duration % 60
		
		if Hour > 0 then
			return String("%02d:%02d:%02d", Hour, Min, Sec)
		else
			return String("%02d:%02d", Min, Sec)
		end
	end

	function I.Latest()
		I.Temp.Index = I.Clear()
		I.Session()
	end

	function I.Report(Input, Find, Mode)
		local G, Session, Text, Total = (I.Temp.Complete or G), F, F, 0.0
		local Current = {G.Sort[1], G.Sort[2]}
		local Show = I.Copy:GetVisible()
		local Data = I.Search(Find)
		
		if Data then
			G.Sort[1], G.Sort[2] = Data.Event, Data.Type
			Session = I.Session(O, 0, 0)
			G.Sort = Current
		end
		
		if not Session then
			return (I.Copy:SetKeyFocus(F) or I.Copy:SetSelection() or I.Copy:SetVisible(F))
		end
		
		for k,v in Pairs(I.Data) do
			if Session.Time and v[Input.Type][Input.Event] then
				Text = String("%0s [%0s: %0s]", Text or "", v.Detail.Name, Gsub(I.Short(Match(Mode, "PS") and v[Input.Type][Input.Event] / Session.Time.Duration or v[Input.Type][Input.Event] or 0), "%s", ""))
			else
				Text = String("%0s [%0s: 0]", Text or "", v.Detail.Name)
			end
			
			Total = Total + (Match(Mode, "PS") and v[Input.Type][Input.Event] and v[Input.Type][Input.Event] / Session.Time.Duration or v[Input.Type][Input.Event] or 0)
		end
		
		if Input and Mode then
			Text = String("[%0s] [%0s: %0s]%0s", I.Duration(Session), Mode, Gsub(I.Short(Total), "%s", ""), Text)
			I.Copy:SetText(Text)
		end
		
		if not Show then
			I.Copy:SetSelection(0, I.Copy:GetText():len())
			I.Copy:SetKeyFocus(T)
		else
			I.Copy:SetKeyFocus(F)
			I.Copy:SetSelection()
		end
		
		I.Copy:SetVisible(not Show)
	end

	function I.Reset()
		G.LogX, G.LogY, G.MainX, G.MainY, G.TipX, G.TipY = 0, 0, 0, 0, 0, 0
		
		if not I.Temp.Complete then
			I.Main:SetPoint(G.Point[1], UIParent, "CENTER", G.MainX, G.MainY)
		else
			I.Main:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		end
		
		I.Tip:SetPoint(G.Point[2], UIParent, "CENTER", G.TipX, G.TipY)
		I.Log:SetPoint("CENTER", UIParent, "CENTER", G.LogX, G.LogY)
	end

	function I.Search(Input)
		local Data = {Event = F, Type = F}
		local G = (I.Temp.Complete or G)
		
		if G.Mode[Input] == "ASB" then
			Data.Event = "Absorbed"
			Data.Type = "Taken"
		end
		
		if G.Mode[Input] == "AVD" then
			Data.Event = "Avoided"
			Data.Type = "Taken"
		end
		
		if G.Mode[Input] == "BLK" then
			Data.Event = "Blocked"
			Data.Type = "Taken"
		end
		
		if G.Mode[Input] == "DMG" then
			Data.Event = "Damage"
			Data.Type = "Given"
		end
		
		if G.Mode[Input] == "DPS" then
			Data.Event = "Damage"
			Data.Type = "Given"
		end
		
		if G.Mode[Input] == "DTN" then
			Data.Event = "Damage"
			Data.Type = "Taken"
		end
		
		if G.Mode[Input] == "HLG" then
			Data.Event = "Heal"
			Data.Type = "Given"
		end
		
		if G.Mode[Input] == "HPS" then
			Data.Event = "Heal"
			Data.Type = "Given"
		end
		
		if G.Mode[Input] == "HTN" then
			Data.Event = "Heal"
			Data.Type = "Taken"
		end
		
		if G.Mode[Input] == "INT" then
			Data.Event = "Intercepted"
			Data.Type = "Taken"
		end
		
		if G.Mode[Input] == "MSD" then
			Data.Event = "Missed"
			Data.Type = "Given"
		end
		
		if G.Mode[Input] == "OHG" then
			Data.Event = "Overheal"
			Data.Type = "Given"
		end
		
		if G.Mode[Input] == "OKL" then
			Data.Event = "Overkill"
			Data.Type = "Given"
		end
		
		if G.Mode[Input] == "OPS" then
			Data.Event = "Overheal"
			Data.Type = "Given"
		end
		
		return Data
	end

	function I.Select(Frame, Top)
		local Mouse = (Frame and Inspect.Mouse())
		
		if Frame == "Meter" or Frame == "Units" then
			I.Temp[Frame] = (G.Slots.Start > 1 and G.Slots.Start - 1 or 0) + Integer((Mouse.y + 18.00) - Top) / 20
		end
		
		if Frame == "Events" or Frame == "Mini" then
			I.Temp[Frame] = Integer((Mouse.y + 14.00) - Top) / 20
		end
	end

	function I.Session(Update, Return, Skip)
		local Session = (E.Active and E.Data or E.Sessions[#E.Sessions])
		
		if I.Temp.Index then
			Session = E.Sessions[I.Temp.Index]
		end
		
		if Return then
			return (Skip and I.Update(Session, 0) or Session)
		end
		
		if Update then
			if Update == E.Interface[2] then
				E.Interface[2].Session(0)
			end
		else
			G.Slots.Stop = G.Slots.Value
			G.Slots.Start = 1
			I.Mini.Update()
		end
		
		I.Update(Session)
	end

	function I.Short(Input)
		if not Input then return end
		
		if Input < 10000 then
			return String("%d", Input)
		elseif Input < 100000 then
			return String("%2.1fK", Input / 1000)
		elseif Input < 1000000 then
			return String("%3dK", Input / 1000)
		elseif Input < 10000000 then
			return String("%2.2fM", Input / 1000000)
		elseif Input < 100000000 then
			return String("%3.1fM", Input / 1000000)
		elseif Input < 1000000000 then
			return String("%3dM", Input / 1000000)
		elseif Input < 10000000000 then
			return String("%2.2fB", Input / 1000000000)
		elseif Input < 100000000000 then
			return String("%3.1fB", Input / 1000000000)
		elseif Input < 1000000000000 then
			return String("%3dB", Input / 1000000000)
		elseif Input < 10000000000000 then
			return String("%2.2fT", Input / 1000000000000)
		elseif Input < 100000000000000 then
			return String("%3.1fT", Input / 1000000000000)
		else
			return String("%3dT", Input / 1000000000000)
		end
	end

	function I.Sort(A, B)
		local G = (I.Temp.Complete or G)
		local Event = G.Sort[1]
		local Type = G.Sort[2]
		
		if not A or not A[Type] or not A[Type][Event] then
			A = {[Type] = {[Event] = 0}}
		end
		
		if not B or not B[Type] or not B[Type][Event] then
			B = {[Type] = {[Event] = 0}}
		end
		
		if not G.Desc then
			return A[Type][Event] > B[Type][Event]
		else
			return A[Type][Event] < B[Type][Event]
		end
	end

	function I.Tooltip(Input, Mode, Advanced)
		local C, P = {"Critical Count", "Critical Total", "Critical Max", "Critical Min"}, {"Pet Critical", "Pet Normal"}
		local N, U = {"Normal Count", "Normal Total", "Normal Max", "Normal Min"}, {"Unit Critical", "Unit Normal"}
		local Cap, Session, PS, Reset = {10, 22, 32}, I.Session(0, 0, 0), Match(Mode or "", "%aPS"), O
		local Avoid, Block = (Mode == "AVD" or Mode == "MSD"), (Mode == "BLK")
		local Abilities, Count, Text, Units = {}, {}, {}, {}
		local Index = Integer(I.Temp.Meter or 0)
		local Data = I.Data[Index]
		
		if I.Tip:GetVisible() and (I.Temp.Complete or not G.Over) or not Data or not Input or not Mode or not Session then
			I.Temp.Advanced, I.Temp.Display, I.Temp.TipX, I.Temp.TipY = O, O, O, O
			return I.Tip:SetVisible(F)
		end
		
		if I.Tip:GetVisible() and not Advanced and String("%0s%0s", Data.Detail.Unit, Mode) == I.Temp.Display then
			return else I.Tip:SetVisible(F) Reset = I.Tip:ClearAll()
		end
		
		if not Advanced then
			I.Tip:SetPoint(G.Point[2], UIParent, "CENTER", G.TipX, G.TipY)
		else
			I.Tip:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		end
		
		if Input and Mode then
			local Total = Data[Input.Type][Input.Event]
			local Unit = Session[Data.Detail.Unit]
			local Time = Session.Time.Duration
			
			for k,v in Pairs(Unit.Abilities) do
				local Info = (v[Input.Type] and v[Input.Type][Input.Event])
				local Units = (Info and Info.Units or Count)
				
				if Info and Next(Info) then
					local Ability = Abilities[#Abilities + 1]
					
					if not Ability then
						Abilities[#Abilities + 1] = {Ability = k, Total = (Info[C[2]] or 0) + (Info[N[2]] or 0)}
						Ability = Abilities[#Abilities]
					end
					
					if Avoid then
						Ability.Total = (Info[C[1]] or 0) + (Info[N[1]] or 0)
					end
					
					if Advanced then
						Ability[C[1]], Ability[C[2]] = (Info[C[1]] or 0), (Info[C[2]] and PS and Info[C[2]] / Time or (Info[C[2]] or 0))
						Ability[C[3]] = (Info[C[3]] and PS and Info[C[3]] / Time or (Info[C[3]] or 0))
						Ability[C[4]] = (Info[C[4]] and PS and Info[C[4]] / Time or (Info[C[4]] or 0))
						
						Ability[N[1]], Ability[N[2]] = (Info[N[1]] or 0), (Info[N[2]] and PS and Info[N[2]] / Time or (Info[N[2]] or 0))
						Ability[N[3]] = (Info[N[3]] and PS and Info[N[3]] / Time or (Info[N[3]] or 0))
						Ability[N[4]] = (Info[N[4]] and PS and Info[N[4]] / Time or (Info[N[4]] or 0))
					else
						Abilities.Total = (Abilities.Total or 0) + (Info[C[1]] or 0) + (Info[N[1]] or 0)
						Abilities.Critical = (Abilities.Critical or 0) + (Info[C[1]] or 0)
						Abilities.Normal = (Abilities.Normal or 0) + (Info[N[1]] or 0)
						
						if Block then
							Abilities.Tally = (Abilities.Tally or 0) + (v.Tally[Input.Type] or 0)
						end
						
						if Input.Event == "Heal" and Match(k, "Absorb") then
							Abilities.Ignore = (Abilities.Ignore or 0) + (Info[N[1]] or 0)
						end
						
						if PS then
							Ability.Total = (Ability.Total / Time or 0)
						end
						
						for k,v in Pairs(Units) do
							Count[k] = (Count[k] or 0) + (v or 0)
						end
					end
				end
				
				if C or N then
					Info = v[Input.Type] and v[Input.Type]["Damage"]
				end
				
				if not Block and Info and Next(Info) then
					Abilities.Tally = (Abilities.Tally or 0) + (Info[C[1]] or 0) + (Info[N[1]] or 0)
				end
			end
			
			if Avoid or Avoid and Total then
				Abilities.Tally = (Abilities.Tally or 0) + (Abilities.Total or 0)
			end
			
			for k,v in Pairs(Count) do
				if not Advanced and v then
					Units[#Units + 1] = {Name = k, Total = PS and v / Time or v}
				end
			end
			
			if #Abilities > 0 and Total then
				Sort(Abilities, function(A, B) return A.Total > B.Total end)
				Sort(Units, function(A, B) return A.Total > B.Total end)
			else
				I.Temp.Advanced, I.Temp.Display = O, O
				I.Temp.TipX, I.Temp.TipY = O, O
				return I.Tip:SetVisible(F)
			end
			
			if not Advanced and PS then
				Total = Total / Time
			end
			
			for k,v in Pairs(Abilities) do
				local Index = (not Match(k, "%a+") and v.Total > 0)
				
				if not Advanced and Index and not (k > Cap[3]) then
					if not Match(Unit.Abilities[v.Ability].Tooltip, "(Pet)") then
						Text.Unit = String("%0s%-8s\t%-10s\t%0s\n", (Text.Unit or ""), I.Short(v.Total), String("[%.2f%%]", v.Total / Total * 100), Unit.Abilities[v.Ability].Tooltip)
					else
						Text.Pet = String("%0s%-8s\t%-10s\t%0s\n", (Text.Pet or ""), I.Short(v.Total), String("[%.2f%%]", v.Total / Total * 100), Unit.Abilities[v.Ability].Tooltip)
					end
				end
				
				if Advanced and Index and not (k > Cap[2]) then
					local Critical = (v[C[3]] > 0 and v[C[4]] > 0 and v[C[2]] / v[C[1]] or 0)
					local Normal = (v[N[3]] > 0 and v[N[4]] > 0 and v[N[2]] / v[N[1]] or 0)
					local Crit, Norm = F, F
					
					Crit = String("%-14s\t%-14s\t%-14s\t%-18s\t", String("Max: %0s", I.Short(v[C[3]])), String("Avg: %0s", I.Short(Critical)), String("Min: %0s", I.Short(v[C[4]])), String("Count: %0s", I.Short(v[C[1]])))
					Norm = String("%-14s\t%-14s\t%-14s\t%-18s\t", String("Max: %0s", I.Short(v[N[3]])), String("Avg: %0s", I.Short(Normal)), String("Min: %0s", I.Short(v[N[4]])), String("Count: %0s", I.Short(v[N[1]])))
					
					if not Match(Unit.Abilities[v.Ability].Tooltip, "(Pet)") then
						Text[U[1]] = String("%0s%0s%0s", (Text[U[1]] and Text[U[1]] .. "\n" or ""), Crit, Unit.Abilities[v.Ability].Tooltip)
						Text[U[2]] = String("%0s%0s%0s", (Text[U[2]] and Text[U[2]] .. "\n" or ""), Norm, Unit.Abilities[v.Ability].Tooltip)
					else
						Text[P[1]] = String("%0s%0s%0s", (Text[P[1]] and Text[P[1]] .. "\n" or ""), Crit, Unit.Abilities[v.Ability].Tooltip)
						Text[P[2]] = String("%0s%0s%0s", (Text[P[2]] and Text[P[2]] .. "\n" or ""), Norm, Unit.Abilities[v.Ability].Tooltip)
					end
				end
			end
			
			for k,v in Pairs(Units) do
				if not Advanced and not (k > Cap[1]) and v.Total > 0 then
					Text.Count = String("%0s%-8s\t%-10s\t%0s\n", (Text.Count or ""), I.Short(v.Total), String("[%.2f%%]", v.Total / Total * 100), v.Name)
				end
			end
			
			if not Advanced then
				local Detail = String("%0s's [%0s] [%0s] Basic Breakdown", Data.Detail.Name, Gsub((Unit.Calling or "NPC"), "^%l", Upper), Mode)
				local Pet = (Text.Unit and Text.Pet and "\n" .. Text.Pet or Text.Pet)
				local Tally = (Abilities.Tally or Abilities.Total)
				local Info = F
				
				if not Avoid and not Block and not (Mode == "ASB" or Mode == "INT") then
					Info = String("[Ability Count: %0s] [Critical: %0s] [%.2f%%]", Abilities.Total, Abilities.Critical, Abilities.Critical / (Abilities.Total - (Abilities.Ignore and Abilities.Ignore - 0.002 or 0)) * 100)
				else
					Info = String("[Ability Count: %0s] [%0s: %0s] [%.2f%%]", Tally, Input.Event, Abilities.Total, Abilities.Total / Tally * 100)
				end
				
				Text.Out = String("%0s\n\n%0s\n\n%0s\n%0s%0s", Detail, Info, Text.Count or "", Text.Unit or "", Pet or "")
			else
				local Detail = String("%0s's [%0s] [%0s] Advanced Breakdown", Data.Detail.Name, Gsub((Unit.Calling or "NPC"), "^%l", Upper), Mode)
				local Critical = String("%0s%0s", Text[U[1]] or "", (Text[P[1]] and Text[U[1]] and "\n\n" .. Text[P[1]] or Text[P[1]] or ""))
				local Normal = String("%0s%0s", Text[U[2]] or "", (Text[P[2]] and Text[U[2]] and "\n\n" .. Text[P[2]] or Text[P[2]] or ""))
				
				Text.Out = String("%0s\n\nNormal:\n\n%0s\n\nCritical:\n\n%0s", Detail, Normal, Critical)
			end
			
			if Text.Out then
				I.TipTX:SetText(Text.Out)
				I.Tip:SetVisible(T)
			end
		end
		
		if Text.Out then
			I.Temp.Display = not Advanced and String("%0s%0s", Data.Detail.Unit, Mode)
			I.Tip:SetWidth(I.TipTX:GetWidth() + 28 + 12.00)
			I.Tip:SetHeight(I.TipTX:GetHeight() + 16.00)
			I.TipBG:SetHeight(I.Tip:GetHeight() - 8)
			I.TipBG:SetWidth(I.Tip:GetWidth() - 8)
		end
	end

	function I.Update(Input, Skip)
		if not Input or not Input.Time or I.Mouse.LeftM then return end
		
		local Detail = Inspect.Unit.Detail
		local Time = Input.Time.Duration
		local Total = {"Total"}
		local Text = {}
		
		if Time and Time - 0.2 < 0 then
			Time = 0.88
		end
		
		if #I.Data > 0 then
			I.Data = {}
		end
		
		for k,v in Pairs(Input) do
			local Unit = (v.Name and not v.Relation and Detail(k))
			local Run = Match(v.Name or "", "%a+")
			
			if Run and not v.Relation then
				v.Relation = (Unit and Unit.relation or Unit and (Unit.alliance == User.alliance and "friendly" or Unit.role and "friendly") or "hostile")
			end
			
			if not E.Active and v.Relation == "friendly" and v.Name and not v.Player then
				Run, v.Name = O, O
			end
			
			if v.Relation == "friendly" and v.Name and not v.Player then
				Run = O
			end
			
			if G.Slots.Value == 1 then
				if G.Side == "friendly" and not (k == E.User) then
					Run = (v.Name and F)
				else
					G.Slots.Stop = 5
				end
			end
			
			if G.Side == v.Relation and Run then
				I.Data[#I.Data + 1] = {Detail = {Name = v.Name, Unit = k}, Given = {}, Taken = {}}
				
				for k,v in Pairs(v.Abilities) do
					for k,v in Pairs(v.Given or {}) do
						I.Data[#I.Data].Given[k] = I.Count(I.Data[#I.Data].Given[k], k, v)
					end
					
					for k,v in Pairs(v.Taken or {}) do
						I.Data[#I.Data].Taken[k] = I.Count(I.Data[#I.Data].Taken[k], k, v)
					end
				end
			end
		end
		
		if #I.Data > 0 then
			Sort(I.Data, I.Sort)
		end
		
		for k,v in Pairs(I.Data) do
			local Coding = (Input[v.Detail.Unit] and Input[v.Detail.Unit].Calling)
			local Valid = (k >= G.Slots.Start and k <= G.Slots.Stop)
			local G = (I.Temp.Complete or G)
			
			if Coding then
				Coding = (Coding == "cleric" and '<font color="#40C412">' or Coding == "mage" and '<font color="#A86BFF">' or Coding == "rogue" and '<font color="#E0E028">' or Coding == "warrior" and '<font color="#FC3232">' or Coding == "primalist" and '<font color="#33D4FF">' or '<font color="#E68A00">')
			else
				Coding = (not Coding and '<font color="#E68A00">')
			end
			
			if Coding and v.Detail.Unit == E.User then
				Coding = '<font color="#488DFF">'
			end
			
			for i = 1, G.Modes do
				local Mode = I.Search(i)
				local Output = F
				
				if Mode then
					Output = (v[Mode.Type] and v[Mode.Type][Mode.Event] or 0)
				end
				
				if Output and Match(G.Mode[i], "%aPS") then
					Output = Output / Time
				end
				
				if Valid then
					Text[i + 1] = String("%0s%0s%5s</font>\n", (Text[i + 1] or ""), Coding, I.Short(Output or 0))
				end
				
				Total[i + 1] = (Total[i + 1] or 0) + (Output or 0)
			end
			
			if Valid then
				Text[1] = String("%0s%0s%0s: %0s</font>\n", (Text[1] or ""), Coding, k, v.Detail.Name)
			end
		end
		
		if #Text > 0 and not Skip then
			local G = (I.Temp.Complete or G)
			
			for i = 1, G.Modes do
				if Text[i + 1] and I["Meter" .. i] then
					I["Meter" .. i]:SetText(String("%0s%5s", Text[i + 1], I.Short(Total[i + 1])), T)
				end
			end
			
			I.Units:SetText(String("%0s%0s: %0s", Text[1], #I.Data, Total[1]), T)
			I.Main:SetHeight(I.Units:GetHeight() + 28.00 - 0.88)
			I.MainBG:SetHeight(I.Main:GetHeight() - 8)
			I.Time:SetText(I.Duration(Input))
		end
	end

	if RGM_Global[2].Show and not E.Interface[2] then
		E.Interface[2] = {Build = {}, Data = {}, Mouse = {}, Temp = {}}
		E.Build.Interface()
	end

	if G.Toggle then
		I.Main:SetVisible(F)
	end

	if G.MiniShow and G.MiniQuick then
		I.Mini:SetVisible(T)
		I.Mini.Update(F)
		G.MiniShow = T
	else
		I.Mini:SetVisible(F)
		G.MiniShow = F
	end

	I.Main:SetHeight(I.Units:GetHeight() + 24.00)
	I.MainBG:SetHeight(I.Main:GetHeight() - 8)
	E.Global = I.Density(I.Build.Modes())
end